// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "SimpleKeyboardMsg.h"
#include "ChildView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CChildView

CChildView::CChildView()
{
	m_gPos.x = m_gPos.y = 0;
	m_kPos.x = m_kPos.y = 0;
}

CChildView::~CChildView()
{
}


BEGIN_MESSAGE_MAP(CChildView, CWnd)
	ON_WM_PAINT()
	ON_WM_CHAR()
	ON_WM_SIZE()
	ON_WM_KEYDOWN()
	ON_WM_SETFOCUS()
	ON_WM_KILLFOCUS()
	ON_WM_CREATE()
END_MESSAGE_MAP()



// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), reinterpret_cast<HBRUSH>(COLOR_WINDOW+1), NULL);

	return TRUE;
}

void CChildView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	CRect rect;
	GetClientRect(&rect);
	dc.DrawText(m_str, &rect, DT_LEFT);

    dc.SelectStockObject(GRAY_BRUSH);
    dc.Rectangle(m_gPos.x-10, m_gPos.y-10, m_gPos.x+10, m_gPos.y+10);	// draw rectangle graphic object
	
	// Do not call CWnd::OnPaint() for painting messages
}

void CChildView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	HideCaret();	// ĳ .

	if(nChar >= 32){ // ASCII  ڸ ܽŲ.
		m_str += (char) nChar;
		m_kPos.x += m_size.cx;
		Invalidate();
	}

	SetCaretPos(m_kPos); // ġ 
	ShowCaret();	// ĳ ٽ δ.
	
	CWnd ::OnChar(nChar, nRepCnt, nFlags);
}

void CChildView::OnSize(UINT nType, int cx, int cy) 
{
	CWnd ::OnSize(nType, cx, cy);
	
	m_gPos.x = cx/2;
	m_gPos.y = cy/2;	
}

void CChildView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
    switch(nChar){
    case VK_RETURN:
        m_str += "\n";
		m_kPos.x = 0;		// ĳ ġ 
		m_kPos.y += m_size.cy;
        break;
    case VK_LEFT:
        m_gPos.x -=10;
        break;
    case VK_RIGHT:
        m_gPos.x +=10;
        break;
    case VK_UP:
        m_gPos.y -=10;
        break;
    case VK_DOWN:
        m_gPos.y +=10;
        break;
    }
    Invalidate();
	
	CWnd ::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CChildView::OnSetFocus(CWnd* pOldWnd) 
{
	CWnd ::OnSetFocus(pOldWnd);
	
	CreateSolidCaret(20, 20); // ĳ 
	SetCaretPos(m_kPos); // ġ 
	ShowCaret(); // ȭ鿡 ̵ Ѵ.
}

void CChildView::OnKillFocus(CWnd* pNewWnd) 
{
	CWnd ::OnKillFocus(pNewWnd);
	
	HideCaret(); // .
	::DestroyCaret(); // ıѴ.
}

int CChildView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	// TODO:  Add your specialized creation code here
	CDC dc;
	dc.CreateCompatibleDC(NULL);
	TEXTMETRIC tm;
	dc.GetTextMetrics(&tm);
	
	m_size.cx = tm.tmAveCharWidth;	//  ũ ̸ 
	m_size.cy = tm.tmHeight;

	return 0;
}
